#include "GetPoint.js"

function SplitCurveAtPoint( crv, pt )
{
	var pt_factory = moi.command.createFactory( 'point' );
	pt_factory.setInput( 0, pt );
	var pt_list = pt_factory.calculate();

	var crv_list = moi.geometryDatabase.createObjectList();
	crv_list.addObject( crv );

	var trim_factory = moi.command.createFactory( 'trim' );
	trim_factory.setInput( 0, crv_list ); // Objects to trim.
	trim_factory.setInput( 1, pt_list ); // Cutting objects.
	trim_factory.setInput( 2, moi.geometryDatabase.createObjectList() ); // Selected fragments.
	
	trim_factory.generateFragments();
	trim_factory.finishedPickingFragments();
	
	trim_factory.update();
	trim_factory.commit();
}

function DoSplitAtPoint()
{
	var pointpicker = moi.ui.createPointPicker();
	pointpicker.enableOnObjectSnap = true;

	var processed = [];
		
	while ( 1 )
	{
		if ( !GetPoint( pointpicker ) )
			return false;

		var pickedpt = pointpicker.pt;
		var foundone = false;

		for ( var i = 0; i < pickedpt.numOsnaps; ++i )
		{
			var osnap = pickedpt.osnap(i);

			if ( osnap.isOnCurve )
			{
				for ( var j = 0; j < 2; ++j )
				{
					var obj = (j == 0 ? osnap.object : osnap.otherObject);
					if ( obj && (obj.isCurve || obj.isCurveSegment) )
					{
						if ( obj.isCurveSegment )
							obj = obj.getParentObject();

						if ( !processed[obj.id] )
						{
							processed[obj.id] = true;
							foundone = true;

							SplitCurveAtPoint( obj, pickedpt );
						}
					}
				}
			}
		}

		if ( foundone )
			break;
	}
}

DoSplitAtPoint();
